// DTMF1.cpp: implementation of the DTMF class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Dtmf.h"
#include "DTMF1.h"
#include "playBuffer.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

playBuffer p(0.2, 8, 8000);

DTMF::DTMF()
{

}

DTMF::~DTMF()
{

}

void DTMF::generateTone(char key)
{
	switch(key)
	{
	case '1':
		generateTone(1, 1);
		break;
	case '2':
		generateTone(1, 2);
		break;
	case '3':
		generateTone(1, 3);
		break;
	case '4':
		generateTone(2, 1);
		break;
	case '5':
		generateTone(2, 2);
		break;
	case '6':
		generateTone(2, 3);
		break;
	case '7':
		generateTone(3, 1);
		break;
	case '8':
		generateTone(3, 2);
		break;
	case '9':
		generateTone(3, 3);
		break;
	case '*':
		generateTone(4, 1);
		break;
	case '0':
		generateTone(4, 2);
		break;
	case '#':
		generateTone(4, 3);
		break;
	}
}

void DTMF::generateTone(int row, int col)
{
	int rowFreq;
	int colFreq;

	switch(row)
	{
	case 1:
		rowFreq = 697;
		break;
	case 2:
		rowFreq = 770;
		break;
	case 3:
		rowFreq = 852;
		break;
	case 4:
		rowFreq = 941;
		break;
	}

	switch(col)
	{
	case 1:
		colFreq = 1209;
		break;
	case 2:
		colFreq = 1336;
		break;
	case 3:
		colFreq = 1477;
		break;
	case 4:
		colFreq = 1633;
		break;
	}

	// We only need about 3300 hz to accurately generate the 
	// tones (1633 * 2 = 3266) so 8000 samples a second should
	// be more than enough
	
	for(float i=0; i<p.sampleCount; i++)
	{
		float t = i/8000;
		p.data[(int)i] = sin((t*rowFreq) * 2 * 3.14159) * .5;
		p.data[(int)i] += sin((t*colFreq) * 2 * 3.14159) * .5;
		
	}
	p.updateBuffer();
	p.play();
	//while(p.isPlaying());
}
